//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  CornflowerBlue
#property indicator_color2  Red
#property indicator_color3  Red
#property indicator_color4  CornflowerBlue
#property indicator_color5  Red
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  1
#property indicator_width5  1

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern int    Lb              = 5;
extern int    MaFilterPass    = 2;
extern int    MaShift         = 0;
extern bool   ArrowOnLast     = false;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double ssl[];
double sslDa[];
double sslDb[];
double arrowUp[];
double arrowDn[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
    IndicatorBuffers(6);
    SetIndexBuffer(0,ssl);  SetIndexDrawBegin(0,Lb+1);
    SetIndexBuffer(1,sslDa);
    SetIndexBuffer(2,sslDb);
    SetIndexBuffer(3,arrowUp); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,241);
    SetIndexBuffer(4,arrowDn); SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,242);
    SetIndexBuffer(5,trend);
    
    //
    //
    //
    //
    //
     
        MaFilterPass      = MathMax(MathMin(MaFilterPass,48),1);
        Lb                = MathMax(Lb,2);
        indicatorFileName = WindowExpertName();
        calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
        returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);
 
        for (int i=0;i<4;i++) SetIndexShift(i,MaShift*timeFrame/Period());
   IndicatorShortName(timeFrameToString(timeFrame)+"  MultiPass SSL("+Lb+")");
   return(0);
}
   

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,n,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { ssl[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (trend[limit] == -1) ClearPoint(limit,sslDa,sslDb);
      for(i=limit;i>=0;i--)
      {
         trend[i]   = trend[i+1];
         sslDa[i]   = EMPTY_VALUE;
         sslDb[i]   = EMPTY_VALUE;
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
      
            double hi = iMultiPassMa(iMA(NULL,0,1,0,MODE_SMA,PRICE_HIGH,i+1),Lb,MaFilterPass,i+1,0);
            double lo = iMultiPassMa(iMA(NULL,0,1,0,MODE_SMA,PRICE_LOW, i+1),Lb,MaFilterPass,i+1,1);
               if(Close[i] > hi) trend[i] =  1;
               if(Close[i] < lo) trend[i] = -1;
               if(trend[i] == -1)
                     ssl[i] = hi;
               else  ssl[i] = lo;
               if (trend[i] == -1) PlotPoint(i,sslDa,sslDb,ssl);
               if (trend[i] != trend[i+1])
                  if (trend[i]==1) 
                        arrowUp[i] = ssl[i]-3.0*iATR(NULL,0,10,i)/4.0;
                  else  arrowDn[i] = ssl[i]+3.0*iATR(NULL,0,10,i)/4.0;
                  
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   int displace = 1; if (ArrowOnLast) displace=-1;
   if (trend[limit]==-1) ClearPoint(limit,sslDa,sslDb);
   for (i=limit;i>=0; i--)
   {
       int y = iBarShift(NULL,timeFrame,Time[i]);
       int x = iBarShift(NULL,timeFrame,Time[i+displace]);
          ssl[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lb,MaFilterPass,MaShift,ArrowOnLast,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,0,y);
          trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Lb,MaFilterPass,MaShift,ArrowOnLast,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y); 
          sslDa[i]   = EMPTY_VALUE;
          sslDb[i]   = EMPTY_VALUE;
          arrowUp[i] = EMPTY_VALUE;
          arrowDn[i] = EMPTY_VALUE;
          if (x!=y)
          {
            int z = iBarShift(NULL,0,iTime(NULL,timeFrame,y+1));
            if (trend[i] != trend[z])
               if (trend[i]==1) 
                     arrowUp[i] = ssl[i]-3.0*iATR(NULL,0,10,i)/4.0;
               else  arrowDn[i] = ssl[i]+3.0*iATR(NULL,0,10,i)/4.0;
          }
          
          //
          //
          //
          //
          //
                        
          if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

          //
          //
          //
          //
          //

          datetime time = iTime(NULL,timeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
  	           ssl[i+k] = ssl[i]+(ssl[i+n] - ssl[i]) * k/n;
   }
   for (i=limit;i>=0;i--) if (trend[i]==-1) PlotPoint(i,sslDa,sslDb,ssl);      
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workMpFilter[][50][2];
double iMultiPassMa(double price, int period, int filterPass, int i, int instanceNo=0)
{ 
   if (ArrayRange(workMpFilter,0) != Bars) ArrayResize(workMpFilter,Bars); i = Bars-i-1; 

   double ma = 0;
   for (int p=0; p<filterPass; p++)
   {
      if (p==0) workMpFilter[i][0][instanceNo] = price;
      if (i>=period)
               ma = workMpFilter[i-1][p+1][instanceNo]+(workMpFilter[i][p][instanceNo]-workMpFilter[i-period][p][instanceNo])/period;
      else {   ma = workMpFilter[i][p][instanceNo]; for (int k=1; k<period && (i-k)>=0; k++) ma += workMpFilter[i-k][p][instanceNo];
                                                                                             ma /= k; }
      workMpFilter[i][p+1][instanceNo] = ma;
   }               
   return(ma);
}      


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(Period())," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," ssl changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//
//
//
//
//


